const path = require('path');

module.exports = {
  root: true,
  extends: [
    '@tencentcloud/eslint-config-hybrid',
  ],
  parserOptions: {
    project: [
      `${__dirname}/tsconfig.json`,
    ],
  },
  settings: {
    'import/resolver': {
      alias: {
        map: [['@', path.resolve(__dirname, './src')]],
        extensions: ['.js', '.jsx', '.ts', '.d.ts', '.tsx'],
      },
    },
  },
  rules: {
    'class-methods-use-this': 'off',
    'no-restricted-syntax': 'off',
    'no-plusplus': 'off',
    'no-constructor-return': 'off',
    'no-param-reassign': 'off',
    'no-continue': 'off',
    'import/prefer-default-export': 'off',
    'prefer-promise-reject-errors': 'off',
    '@stylistic/max-len': 'warn',
    '@typescript-eslint/naming-convention': 'off',
    '@typescript-eslint/no-unused-expressions': 'off',
    '@typescript-eslint/no-unused-vars': ["error", {
      "args": "after-used",
    }],
    'prefer-exponentiation-operator': 'off',
    'no-restricted-properties': 'off',
  },
  ignorePatterns: [
    'node_modules',
    'dist',
    'public',
    'build',
    'docs',
    '!.stylelintrc.cjs',
  ],
};
