"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _package = require("../package.json");

var _pluginNodeResolve = _interopRequireDefault(require("@rollup/plugin-node-resolve"));

var _pluginTypescript = _interopRequireDefault(require("@rollup/plugin-typescript"));

var _pluginCommonjs = _interopRequireDefault(require("@rollup/plugin-commonjs"));

var _pluginBabel = _interopRequireDefault(require("@rollup/plugin-babel"));

var _pluginTerser = _interopRequireDefault(require("@rollup/plugin-terser"));

var _rollupPluginDts = _interopRequireDefault(require("rollup-plugin-dts"));

var _rollupPluginReplace = _interopRequireDefault(require("rollup-plugin-replace"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _default = [{
  input: './src/index.ts',
  output: {
    file: './dist/index.js',
    format: 'esm' // sourcemap: true,

  },
  plugins: [(0, _pluginNodeResolve["default"])({
    extensions: ['.js', '.jsx', '.ts', '.tsx', '.mjs', '.cjs'],
    preferBuiltins: false,
    // 专门处理react-native模块
    dedupe: ['react-native']
  }), (0, _pluginCommonjs["default"])({
    transformMixedEsModules: true,
    include: /node_modules/,
    // 强制转换ES模块
    requireReturnsDefault: 'auto',
    // 包含所有可能的扩展名
    extensions: ['.js', '.jsx', '.ts', '.tsx', '.mjs', '.cjs']
  }), (0, _pluginBabel["default"])({
    babelHelpers: 'bundled',
    exclude: 'node_modules/**'
  }), (0, _pluginTypescript["default"])(), (0, _rollupPluginReplace["default"])({
    BUNDLE_VERSION: _package.version
  }), (0, _pluginTerser["default"])()],
  external: ['@tencentcloud/chat-react-native', 'react-native-create-thumbnail']
}, {
  // 生成 .d.ts 类型声明文件
  input: './src/index.ts',
  output: {
    file: './dist/index.d.ts',
    format: 'es'
  },
  plugins: [(0, _rollupPluginDts["default"])()]
}];
exports["default"] = _default;