"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var tui_base_1 = require("../tui-base");
var const_1 = require("../const");
var common_utils_1 = require("../utils/common-utils");
var conversation_1 = require("../model/conversation");
var TUIConversationService = /** @class */ (function (_super) {
    __extends(TUIConversationService, _super);
    function TUIConversationService() {
        var _this = _super.call(this) || this;
        _this.serv = 'TUIConversationService';
        return _this;
    }
    /**
     * 获取 TUIConversationService 实例
    */
    TUIConversationService.getInstance = function () {
        if (!TUIConversationService.instance) {
            TUIConversationService.instance = new TUIConversationService();
        }
        return TUIConversationService.instance;
    };
    TUIConversationService.prototype.init = function () {
        var chatEngine = this.getEngine();
        chatEngine.eventCenter.addEvent(chatEngine.EVENT.CONVERSATION_LIST_UPDATED, this.onConversationListUpdated.bind(this));
        chatEngine.eventCenter.addEvent(chatEngine.EVENT.TOTAL_UNREAD_MESSAGE_COUNT_UPDATED, this.onTotalUnreadCountUpdated.bind(this));
        chatEngine.eventCenter.addEvent(chatEngine.EVENT.MESSAGE_RECEIVED, this.onMessageReceived.bind(this));
        this.getConversationInitData();
    };
    TUIConversationService.prototype.onConversationListUpdated = function (conversationList) {
        var tmpConversationList = this.filterSystemConversation(conversationList);
        this.getEngine().TUIStore.update(const_1.StoreName.CONV, 'conversationList', tmpConversationList);
        this.updateCurrentConversation();
    };
    TUIConversationService.prototype.onTotalUnreadCountUpdated = function (totalUnreadCount) {
        this.getEngine().TUIStore.update(const_1.StoreName.CONV, 'totalUnreadCount', totalUnreadCount);
    };
    TUIConversationService.prototype.onMessageReceived = function (messageList) {
        var chatEngine = this.getEngine();
        var conversationList = this.getEngine().TUIStore.getData(const_1.StoreName.CONV, 'conversationList');
        var toBeUpdated = false;
        for (var i = 0; i < messageList.length; i++) {
            if (messageList[i].type !== chatEngine.TYPES.MSG_GRP_SYS_NOTICE) {
                continue;
            }
            var operationType = messageList[i].payload.operationType;
            var conversationID = "GROUP" + messageList[i].to;
            var condition1 = (operationType === 4 || operationType === 5 || operationType === 8); // 群成员被踢(operationType=4)、群组被解散(operationType=5)、主动退群(operationType=8)
            var condition2 = (operationType === 2 || operationType === 6 || operationType === 7); // 主动加群(operationType=2)、创建群组(operationType=6)、被邀请进群(operationType=7)
            if (condition1 || condition2) {
                for (var j = 0; j < conversationList.length; j++) {
                    // C2C 会话直接跳过，节省循环执行时间
                    if (conversationList[j].type === chatEngine.TYPES.CONV_C2C) {
                        continue;
                    }
                    if (conversationList[j].conversationID === conversationID) {
                        if (condition1) {
                            this.getEngine().TUIStore.update(const_1.StoreName.CONV, 'operationTypeMap', { conversationID: conversationID, operationType: operationType });
                            toBeUpdated = true;
                            break;
                        }
                        // 当前登录生命周期内，主动退群、解散群组、被踢后，再次主动加群、创建群组、被邀请进群时需要重置 operationType 为 0
                        if (condition2 && conversationList[j].operationType > 0) {
                            this.getEngine().TUIStore.update(const_1.StoreName.CONV, 'operationTypeMap', { conversationID: conversationID, operationType: 0 });
                            toBeUpdated = true;
                            break;
                        }
                    }
                }
            }
        }
        if (toBeUpdated) {
            this.getEngine().TUIStore.update(const_1.StoreName.CONV, 'conversationList', conversationList);
            var currentConversationID = this.getEngine().TUIStore.getData(const_1.StoreName.CONV, 'currentConversationID') || '';
            var currentConversation = this.findConversation(currentConversationID);
            if (currentConversation) {
                this.getEngine().TUIStore.update(const_1.StoreName.CONV, 'currentConversation', currentConversation);
            }
        }
    };
    // 解决 TUIChatEngine 含 UI集成通过 TUILogin 登录时注册 Chat SDK 事件时机后置问题
    TUIConversationService.prototype.getConversationInitData = function () {
        var _this = this;
        var chatEngine = this.getEngine();
        // TUIChatEngine 无 UI 集成时不需要执行此逻辑
        if (!chatEngine.chat.isReady()) {
            return;
        }
        chatEngine.chat.getConversationList().then(function (imResponse) { return __awaiter(_this, void 0, void 0, function () {
            var _a, conversationList, isSyncCompleted, totalUnreadCount;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = imResponse.data, conversationList = _a.conversationList, isSyncCompleted = _a.isSyncCompleted;
                        console.log(this.serv + ".init, getConversationList count:" + conversationList.length + " isSyncCompleted:" + isSyncCompleted);
                        if (!(conversationList.length > 0)) return [3 /*break*/, 2];
                        this.onConversationListUpdated(conversationList);
                        return [4 /*yield*/, chatEngine.chat.getTotalUnreadMessageCount()];
                    case 1:
                        totalUnreadCount = _b.sent();
                        this.onTotalUnreadCountUpdated(totalUnreadCount);
                        _b.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        }); });
    };
    TUIConversationService.prototype.switchConversation = function (conversationID) {
        return __awaiter(this, void 0, void 0, function () {
            var logTxt, chatEngine, currentConversationID, targetConversation;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logTxt = this.serv + ".switchConversation";
                        chatEngine = this.getEngine();
                        if (!conversationID) {
                            chatEngine.TUIStore.reset(const_1.StoreName.CHAT, ['messageList', 'isCompleted', 'nextReqMessageID']);
                            chatEngine.TUIStore.update(const_1.StoreName.CONV, 'currentConversationID', '');
                            chatEngine.TUIStore.update(const_1.StoreName.CONV, 'currentConversation', null);
                            console.log(logTxt + " conversationID is empty, conversationID:" + conversationID);
                            return [2 /*return*/, Promise.resolve({})];
                        }
                        if (!conversationID.startsWith(chatEngine.TYPES.CONV_C2C) && !conversationID.startsWith(chatEngine.TYPES.CONV_GROUP)) {
                            console.warn(logTxt + " conversationID is invalid, conversationID:" + conversationID);
                            return [2 /*return*/, Promise.reject({
                                    code: const_1.ERROR_CODE_ENGINE.INVALID_CONV_ID,
                                    message: const_1.ERROR_MSG_ENGINE.INVALID_CONV_ID
                                })];
                        }
                        currentConversationID = chatEngine.TUIStore.getData(const_1.StoreName.CONV, 'currentConversationID');
                        if (currentConversationID && currentConversationID === conversationID) {
                            this.setMessageRead(currentConversationID);
                            console.warn(logTxt + " please check conversationID, conversationID:" + conversationID);
                            return [2 /*return*/, Promise.resolve({
                                    code: const_1.ERROR_CODE_ENGINE.CONV_ID_SAME,
                                    message: const_1.ERROR_MSG_ENGINE.CONV_ID_SAME
                                })];
                        }
                        return [4 /*yield*/, this.getConversationModel(conversationID)];
                    case 1:
                        targetConversation = _a.sent();
                        if (common_utils_1.isUndefined(targetConversation)) {
                            console.warn(logTxt + " target conversation is not exist, conversationID:" + conversationID);
                            return [2 /*return*/, Promise.reject({
                                    code: const_1.ERROR_CODE_ENGINE.CONV_NOT_EXIST,
                                    message: const_1.ERROR_MSG_ENGINE.CONV_NOT_EXIST
                                })];
                        }
                        if (currentConversationID) {
                            this.setMessageRead(currentConversationID);
                        }
                        if (conversationID) {
                            this.setMessageRead(conversationID);
                        }
                        chatEngine.TUIStore.reset(const_1.StoreName.CHAT, ['messageList', 'isCompleted', 'nextReqMessageID']);
                        chatEngine.TUIStore.update(const_1.StoreName.CONV, 'currentConversationID', conversationID);
                        chatEngine.TUIStore.update(const_1.StoreName.CONV, 'currentConversation', targetConversation);
                        return [2 /*return*/, Promise.resolve(targetConversation)];
                }
            });
        });
    };
    TUIConversationService.prototype.getConversationModel = function (conversationID) {
        return __awaiter(this, void 0, void 0, function () {
            var conversationModel, res, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        conversationModel = this.findConversation(conversationID);
                        if (!common_utils_1.isUndefined(conversationModel)) return [3 /*break*/, 4];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.getConversationProfile(conversationID)];
                    case 2:
                        res = _a.sent();
                        if (res.data && res.data.conversation) {
                            conversationModel = new conversation_1["default"](res.data.conversation);
                        }
                        return [3 /*break*/, 4];
                    case 3:
                        error_1 = _a.sent();
                        conversationModel = undefined;
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/, conversationModel];
                }
            });
        });
    };
    TUIConversationService.prototype.findConversation = function (conversationID) {
        var conversation;
        var conversationList = this.getEngine().TUIStore.getData(const_1.StoreName.CONV, 'conversationList');
        for (var i = 0; i < conversationList.length; i++) {
            if (conversationList[i].conversationID === conversationID) {
                conversation = conversationList[i];
                break;
            }
        }
        return conversation;
    };
    TUIConversationService.prototype.updateCurrentConversation = function () {
        var chatEngine = this.getEngine();
        var currentConversationID = chatEngine.TUIStore.getData(const_1.StoreName.CONV, 'currentConversationID');
        var currentConversation = this.findConversation(currentConversationID);
        // 更新当前会话
        if (currentConversation) {
            chatEngine.TUIStore.update(const_1.StoreName.CONV, 'currentConversation', currentConversation);
        }
    };
    TUIConversationService.prototype.getConversationList = function () {
        return this.getEngine().chat.getConversationList();
    };
    TUIConversationService.prototype.getConversationProfile = function (conversationID) {
        return this.getEngine().chat.getConversationProfile(conversationID);
    };
    TUIConversationService.prototype.deleteConversation = function (conversationID) {
        var _this = this;
        return this.getEngine().chat.deleteConversation(conversationID).then(function (imResponse) {
            var currentConversationID = _this.getEngine().TUIStore.getData(const_1.StoreName.CONV, 'currentConversationID');
            console.log(_this.serv + ".deleteConversation conversationID:" + conversationID + " currentConversationID:" + currentConversationID);
            if (conversationID === currentConversationID) {
                _this.getEngine().TUIStore.update(const_1.StoreName.CONV, 'currentConversationID', '');
                _this.getEngine().TUIStore.update(const_1.StoreName.CONV, 'currentConversation', null);
            }
            return imResponse;
        });
    };
    TUIConversationService.prototype.pinConversation = function (options) {
        return this.getEngine().chat.pinConversation(options);
    };
    TUIConversationService.prototype.muteConversation = function (options) {
        return this.getEngine().chat.setMessageRemindType(options);
    };
    TUIConversationService.prototype.clearHistoryMessage = function (conversationID) {
        var _this = this;
        return this.getEngine().chat.clearHistoryMessage(conversationID).then(function (imResponse) {
            _this.getEngine().TUIStore.update(const_1.StoreName.CHAT, 'messageList', []);
            _this.getEngine().TUIStore.update(const_1.StoreName.CHAT, 'nextReqMessageID', '');
            _this.getEngine().TUIStore.update(const_1.StoreName.CHAT, 'isCompleted', true);
            return imResponse;
        });
    };
    TUIConversationService.prototype.setMessageRead = function (conversationID) {
        return this.getEngine().chat.setMessageRead({ conversationID: conversationID });
    };
    TUIConversationService.prototype.setConversationDraft = function (options) {
        var _this = this;
        var conversationID = options.conversationID, _a = options.draftInfo, draftInfo = _a === void 0 ? undefined : _a;
        var draftText = '';
        if (draftInfo) {
            draftText = JSON.stringify(draftInfo);
        }
        return this.getEngine().chat.setConversationDraft({
            conversationID: conversationID,
            draftText: draftText
        }).then(function (imResponse) {
            var conversation = imResponse.data.conversation;
            _this.updateConversation(conversation);
        });
    };
    /**
     * 更新会话信息
     * @param {Conversation} conversation SDK 原始的会话结构体数据
     */
    TUIConversationService.prototype.updateConversation = function (conversation) {
        var isUpdated = false;
        var conversationList = this.getEngine().TUIStore.getData(const_1.StoreName.CONV, 'conversationList');
        for (var i = 0; i < conversationList.length; i++) {
            if (conversationList[i].conversationID === conversation.conversationID) {
                conversationList[i] = conversation;
                isUpdated = true;
                break;
            }
        }
        if (isUpdated) {
            this.getEngine().TUIStore.update(const_1.StoreName.CONV, 'conversationList', conversationList);
        }
    };
    /**
     * 过滤系统会话
     * @param {Array<any>} list SDK 更新下来的会话列表数据
     */
    TUIConversationService.prototype.filterSystemConversation = function (list) {
        var _this = this;
        var toBeUpdatedList = list.filter(function (conversation) { return conversation.type !== _this.getEngine().TYPES.CONV_SYSTEM; });
        return toBeUpdatedList;
    };
    return TUIConversationService;
}(tui_base_1["default"]));
exports["default"] = TUIConversationService;
