import type { IFriendStore } from '../../interface/store';
import type { Friend, FriendApplication } from '../../type';

export default class FriendStore implements IFriendStore {
  public store: {
    friendList: Friend[];
    friendApplicationList: FriendApplication[];
    friendApplicationUnreadCount: number; // 好友申请的未读数
    [key: string]: any;
  };

  public defaultStore = {
    friendList: [],
    friendApplicationList: [],
    friendApplicationUnreadCount: 0,
  } as any;

  constructor() {
    this.store = {
      friendList: [],
      friendApplicationList: [],
      friendApplicationUnreadCount: 0,
    };
  }

  update(key: string, data: any): void {
    this.store[key] = data;
  }

  getData(key: string) {
    return this.store[key];
  }

  reset(keyList: string[] = []) {
    this.store = {
      ...this.defaultStore,
      ...this.store,
      ...keyList.reduce((acc, key) => ({ ...acc, [key]: this.defaultStore[key] }), {}),
    };
  }
}
