import type { SEARCH_TYPE } from '../../type';

export interface ISearchStore {
  store: {
    currentSearchInputValue: {
      value: string;
      searchType: SEARCH_TYPE;
    };
    currentSearchMessageType: {
      value: {
        key: string;
        label: string;
        value: string | string[];
      };
      searchType: SEARCH_TYPE;
    };
    currentSearchMessageTime: {
      value: {
        key: string;
        label: string;
        value: {
          timePosition: number;
          timePeriod: number;
        };
      };
      searchType: SEARCH_TYPE;
    };
    currentSearchingStatus: {
      isSearching: boolean;
      searchType: string;
    };
    isShowInConversationSearch: boolean;
  };

  /**
   * 更新 store
   * @param {Sting} key 待更新的 key
   * @param {any} data 更新的数据
   */
  update(key: string, data: any): void;

  /**
   * 从 store 中获取数据
   * @param {Sting} key 需要获取的 key
   */
  getData(key: string): any;

  /**
   * reset Store 内数据
   * @param { Array<string>} keyList 需要 reset 的 keyList
   */
  reset(keyList?: string[]): void;
}
