"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var const_1 = require("../const");
var common_utils_1 = require("../utils/common-utils");
var tui_base_1 = require("../tui-base");
var MessageModel = /** @class */ (function (_super) {
    __extends(MessageModel, _super);
    function MessageModel(options) {
        var _a;
        var _this = _super.call(this) || this;
        // 维护映射关系，方便使用
        _this.messageHandlers = (_a = {},
            _a[_this.getEngine().TYPES.MSG_TEXT] = function (message) { return _this.getEngine().TUIChat.messageHandler.handleTextMessage(message); },
            _a[_this.getEngine().TYPES.MSG_FACE] = function (message) { return _this.getEngine().TUIChat.messageHandler.handleFaceMessage(message); },
            _a[_this.getEngine().TYPES.MSG_LOCATION] = function (message) { return _this.getEngine().TUIChat.messageHandler.handleLocationMessage(message); },
            _a[_this.getEngine().TYPES.MSG_IMAGE] = function (message) { return _this.getEngine().TUIChat.messageHandler.handleImageMessage(message); },
            _a[_this.getEngine().TYPES.MSG_AUDIO] = function (message) { return _this.getEngine().TUIChat.messageHandler.handleAudioMessage(message); },
            _a[_this.getEngine().TYPES.MSG_VIDEO] = function (message) { return _this.getEngine().TUIChat.messageHandler.handleVideoMessage(message); },
            _a[_this.getEngine().TYPES.MSG_FILE] = function (message) { return _this.getEngine().TUIChat.messageHandler.handleFileMessage(message); },
            _a[_this.getEngine().TYPES.MSG_CUSTOM] = function (message) { return _this.getEngine().TUIChat.messageHandler.handleCustomMessage(message); },
            _a[_this.getEngine().TYPES.MSG_MERGER] = function (message) { return _this.getEngine().TUIChat.messageHandler.handleMergeMessage(message); },
            _a[_this.getEngine().TYPES.MSG_GRP_TIP] = function (message) { return _this.getEngine().TUIChat.messageHandler.handleGroupTipsMessage(message); },
            _a);
        _this._message = options;
        _this._signalingInfo = undefined;
        _this.progress = 0;
        _this.reactionList = [];
        _this.initProperties(options);
        return _this;
    }
    /**
     * 初始化 messageModel 属性
     */
    MessageModel.prototype.initProperties = function (options) {
        var _this = this;
        Object.keys(options).forEach(function (key) {
            if (!common_utils_1.isPrivateKey(key)) {
                _this[key] = options[key];
            }
        });
    };
    MessageModel.prototype.updateProperties = function (options) {
        var _this = this;
        this._message = options;
        Object.keys(options).forEach(function (key) {
            if (!common_utils_1.isPrivateKey(key)) {
                _this[key] = options[key];
            }
        });
    };
    MessageModel.prototype.getMessage = function () {
        return this._message;
    };
    MessageModel.prototype.modifyMessage = function (options) {
        if (options.type && this._message.type !== options.type && !options.payload) {
            return Promise.reject({
                code: const_1.ERROR_CODE_ENGINE.MISMATCH_TYPE_AND_PAYLOAD,
                message: const_1.ERROR_MSG_ENGINE.MISMATCH_TYPE_AND_PAYLOAD
            });
        }
        this._message.type = options.type || this._message.type;
        this._message.payload = options.payload || this._message.payload;
        this._message.cloudCustomData = options.cloudCustomData || this._message.cloudCustomData;
        return this.getEngine().TUIChat.modifyMessage(this._message);
    };
    MessageModel.prototype.revokeMessage = function () {
        return this.getEngine().TUIChat.revokeMessage(this._message);
    };
    MessageModel.prototype.resendMessage = function () {
        return this.getEngine().TUIChat.resendMessage(this._message);
    };
    MessageModel.prototype.deleteMessage = function () {
        return this.getEngine().TUIChat.deleteMessage([this._message]);
    };
    MessageModel.prototype.quoteMessage = function () {
        return this.getEngine().TUIChat.quoteMessage(this._message);
    };
    MessageModel.prototype.replyMessage = function () {
        return this.getEngine().TUIChat.replyMessage(this._message);
    };
    MessageModel.prototype.setMessageExtensions = function (extensions) {
        return this.getEngine().TUIChat.setMessageExtensions(this._message, extensions);
    };
    MessageModel.prototype.getMessageExtensions = function () {
        return this.getEngine().TUIChat.getMessageExtensions(this._message);
    };
    MessageModel.prototype.deleteMessageExtensions = function (keyList) {
        return this.getEngine().TUIChat.deleteMessageExtensions(this._message, keyList);
    };
    MessageModel.prototype.getSignalingInfo = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (this.type !== this.getEngine().TYPES.MSG_CUSTOM) {
                            return [2 /*return*/, null];
                        }
                        if (!common_utils_1.isUndefined(this._signalingInfo)) return [3 /*break*/, 2];
                        _a = this;
                        return [4 /*yield*/, this.getEngine().chat.getSignalingInfo(this._message)];
                    case 1:
                        _a._signalingInfo = _b.sent();
                        return [2 /*return*/, this._signalingInfo];
                    case 2: return [2 /*return*/, this._signalingInfo];
                }
            });
        });
    };
    MessageModel.prototype.getMessageContent = function () {
        var handler = this.messageHandlers[this.type];
        if (common_utils_1.isUndefined(handler)) {
            return {};
        }
        // 群提示消息不支持 showName
        if (this.type === this.getEngine().TYPES.MSG_GRP_TIP) {
            return handler(this._message);
        }
        // 普通消息发送方名称显示优先级(对齐微信体验)
        // C2C 会话：remark > nick > userID
        // 群会话：remark > nameCard > nick > userID
        var friendRemark = this.getEngine().TUIFriend.getFriendRemark([this.from]);
        return __assign(__assign({}, handler(this._message)), { showName: friendRemark[this.from] || this.nameCard || this.nick || this.from });
    };
    MessageModel.prototype.sendForwardMessage = function (conversationList) {
        return this.getEngine().TUIChat.sendForwardMessage(conversationList, [this._message]);
    };
    return MessageModel;
}(tui_base_1["default"]));
exports["default"] = MessageModel;
